package com.engine.salary.mapper.datacollection;

import com.engine.salary.entity.datacollection.po.VariableArchiveItemPO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author Harryxzy
 * @ClassName VariableArchiveItemMapper
 * @date 2024/08/07 9:22
 * @description 浮动薪酬档案明细
 */
public interface VariableArchiveItemMapper {
    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<VariableArchiveItemPO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<VariableArchiveItemPO> listSome(@Param("param") VariableArchiveItemPO variableArchiveItem);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    VariableArchiveItemPO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param variableArchiveItem 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(VariableArchiveItemPO variableArchiveItem);

    /**
     * 修改，修改所有字段
     *
     * @param variableArchiveItem 修改的记录
     * @return 返回影响行数
     */
    int update(VariableArchiveItemPO variableArchiveItem);

    /**
     * 修改，忽略null字段
     *
     * @param variableArchiveItem 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(VariableArchiveItemPO variableArchiveItem);

    /**
     * 删除记录
     *
     * @param variableArchiveItem 待删除的记录
     * @return 返回影响行数
     */
    int delete(VariableArchiveItemPO variableArchiveItem);

    /**
     * 查询浮动薪酬档案中已使用的浮动薪资项目
     *
     * @return
     */
    List<Long> listUsingItems();

    /**
     *
     * @param insertList
     * @return
     */
    int batchInsert(@Param("collection") List<VariableArchiveItemPO> insertList);

    void deleteByIds(@Param("collection")List<Long> part);

    void deleteByArchiveIds(@Param("collection")List<Long> part);

    void updateBatchSelective(@Param("list")List<VariableArchiveItemPO> variableArchiveItemPOS);
}
